#ifndef MAP_H_
#define MAP_H_


#include <utils.h>

#define MAX_LANE 4
#define ROAD_LENGTH 12
#define HORIZONTAL 0
#define VERTICAL 1
#define REVERSE 1
#define INPUT 1
#define OUTPUT 0

/* 
 * lane[X] is the lane X
 * lane[X][Y] is the case Y of the lane X (which type is Vehicle*)
 */
struct road {
	int id;
	Crossroad *start;
	Crossroad *end;
	int length;
	int width;
	Vehicle ***lane; 
	int input;
	int load;
};

struct map {
	Road **roads;
	int road_nb;
	sem_t **road_mut;
	Crossroad **crossroads;
	int crossroad_nb;
	Fleet **fleets;
	int fleet_nb;
};

Road *new_road(int len, int width, int input);
void free_road(Road *r);
int add_to_road(Road *r, Vehicle *v);
Vehicle *pop_from_road(Road *r);

Map *new_map();
void free_map(Map *m);

#endif
