#ifndef V_CONTROLLER_H
#define V_CONTROLLER_H

#include <utils.h>
#include <map.h>
#include <semaphore.h>

#define SPAWN_FREQUENCY 1

struct vehicle {
	int id;
	VType type;
	Road *road;
	int speed;
	int timeout;
	int goal;
	int lane;
	int offset;
};

struct fleet {
	int size;
	int nb_v;
	sem_t *mut;
	Vehicle **v;
};

Vehicle *new_vehicle(VType t, Road *r, int g_id);
void free_vehicle(Vehicle *v);
Fleet *new_fleet(int size);
void free_fleet(Fleet *f);

int step_vehicle(Vehicle *v);
void *start_controller(void *arg);


#endif
